#define _WIN32_WINNT  0x0500
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <tchar.h>

//
//  DEFINES
//
#define SERVICE_NAME      TEXT( "My Message Box Instrumentation Service" )
#define EVENT_NAME        TEXT( "MBI_EnumThreadStopEvent" )
#define THREAD_TIMEOUT    5 * 1000  // 5 seconds (millisecond intervals)
#define FILETIMES_IN_SECOND \
                            1000 * 1000 * 10 // FILETIME = 100 ns interval


//////////////////////////////////////////////////////////////////////////////
//// todo: change to desired strings
////
// name of the executable
#define SZAPPNAME            "MBI"
// internal name of the service
#define SZSERVICENAME        "MessagBoxInstrumentation"
// displayed name of the service
#define SZSERVICEDISPLAYNAME "MBI Service"
// list of service dependencies - "dep1\0dep2\0\0"
#define SZDEPENDENCIES       ""
//////////////////////////////////////////////////////////////////////////////

//
//  PROTOS
//
VOID
WINAPI
ServiceMain(
  DWORD   dwArgc,
  LPTSTR  *lpszArgv 
  );

VOID
WINAPI
Handler(
  DWORD   fdwControl 
  );
  
DWORD
WINAPI
ThreadProc(
  LPVOID    lpvParam 
  );

BOOL
CALLBACK
EnumWindowsProc(
  HWND    hWnd,
  LPARAM  lParam 
  );

BOOL
CALLBACK
EnumChildProc(
  HWND    hWnd,
  LPARAM  lParam 
  );

VOID
DoApplicationSpecificHandling(
  HWND    hTargetWindow 
  );

VOID
CALLBACK
RunEnumeration(
  VOID
  );


//
// DEBUG MACROS
//

#define CONSOLE_TITLE L"MBI Debug Console"

//
//  SOM_INIT() -> Initializes console management variables
//
#define SOM_INIT()  g_bConsole=FALSE;g_hConIn=NULL;g_hConOut=NULL;

//
//  INIT_DBG_CONSOLE() -> Opens a console window and gets it's standard handles
//
#define INIT_DBG_CONSOLE()  if(!g_bConsole){\
                                    AllocConsole();\
                                    g_bConsole=TRUE;\
                                    g_hConOut=GetStdHandle(STD_OUTPUT_HANDLE);\
                                    g_hConIn=GetStdHandle(STD_INPUT_HANDLE);\
                                    SetConsoleTitleW(CONSOLE_TITLE);}

//
//  DEBUG_PAUSE( _x ) -> Pauses the console and the application for _x ms.  If
//                       _x == 0, it initiates a system("pause"), causing
//                       "Press any key to continue . . ." message to be
//                       displayed.
//                       All console display macros listen for a keypress.  If a
//                       key has been pressed, the console pauses (like a
//                       CTRL-C in kd).
//
#define DEBUG_PAUSE(_x) _x?Sleep(_x):system("pause")

//
//  DEBUG_NEWLINE() -> Outputs a newline to the console.
//
#define DEBUG_NEWLINE() if(g_bConsole){WriteConsole(g_hConOut,\
                                  TEXT("\n"),\
                                  lstrlen(TEXT("\n")),\
                                  &g_dwWritten,\
                                  NULL); \
                                  if(_kbhit())DEBUG_PAUSE(0);}

                               
//
//  DEBUG_OUT() -> Emits given string to the console.
//
#define DEBUG_OUT(_x) if(g_bConsole){\
                            _sntprintf(g_szOutputString,\
                                  sizeof(g_szOutputString),\
                                  TEXT("[%4.4d]DEBUG: %s\n"),\
                                  GetCurrentThreadId(),\
                                  _x);\
                            WriteConsole(g_hConOut,\
                                    g_szOutputString,\
                                    lstrlen(g_szOutputString),\
                                    &g_dwWritten,\
                                    NULL); \
                                    if(_kbhit())DEBUG_PAUSE(0);}

//
//  FREE_DBG_CONSOLE() -> Pauses, then frees the console window and reinitializes
//                        the console management variables
//
#define FREE_DBG_CONSOLE(_x)  if(g_bConsole){\
                                    _x?DEBUG_PAUSE(0):0;\
                                    FreeConsole();\
                                    g_bConsole=FALSE;\
                                    g_hConOut=NULL;\
                                    g_hConIn=NULL;}


